clear all;

data.xRect = [ 290 290 230 230]; data.yRect = [ 170 200 200 170];

%% vyvoj poctu bodu

if  (exist('homography.mat','file'))
    load ('homography.mat'); 
    IDs = unique(xHistory.ID); nums = zeros(size(xHistory.ID));
    for a = IDs';  nums(a) = sum(xHistory.ID == a); end;
    nums = nums(nums~=0); counts = zeros(max(nums),1);
    for a = 1:max(nums);  counts(a) = sum(nums>=a); end;
    figure; plot(counts,'LineWidth',2); xlabel('Frame number'); ylabel('Number of tracking points'); ylim([0, round(length(IDs)*50)/50 ]); grid on;
    img = im2double(rgb2gray(imread('billa_jpg_283.jpeg')));
    figure; imagesc(img); colormap gray; axis image; hold on;
    plot(xHistory.x(end-counts(end)+1:end),xHistory.y(end-counts(end)+1:end),'Color',hsv2rgb(0,0.9,1),'Marker','x','LineStyle','none');
    title('Remaining points in the last frame');
else
    fprintf('Result file homography.mat not found\n\n');
end

%% homografie dle odevzdaneho .mat souboru
if  (exist('homography.mat','file'))
    load ('homography_ref.mat'); hHistoryRef = hHistory; xHistoryRef = xHistory; load ('homography.mat'); 
    H = eye(3);
    for a = 1:length(hHistory); H = (hHistory{a}./hHistory{a}(3,3)) * H; end
    Href = eye(3);
    for a = 1:length(hHistoryRef); Href = (hHistoryRef{a}./hHistoryRef{a}(3,3)) * Href; end
    fprintf('Your homography result:\n'); disp(H/H(3,3));
    fprintf('Our homography result:\n');  disp(Href/Href(3,3));
    tmp = H * [data.xRect; data.yRect; ones(size(data.xRect))];
    dataOut.xRect = tmp(1,:)./tmp(3,:); dataOut.yRect = tmp(2,:)./tmp(3,:);
    fprintf('Your transformed rectangle:\n'); disp([dataOut.xRect; dataOut.yRect]);
    tmp = Href * [data.xRect; data.yRect; ones(size(data.xRect))];
    dataRef.xRect = tmp(1,:)./tmp(3,:); dataRef.yRect = tmp(2,:)./tmp(3,:);
    fprintf('Our transformed rectangle:\n'); disp([dataRef.xRect; dataRef.yRect]);
    fprintf('Transforming difference:\n'); disp([dataRef.xRect - dataOut.xRect; dataRef.yRect - dataOut.yRect]);
else
    fprintf('Result file homography.mat not found\n\n');
end
%% vypocet homografie z bodu, kontrola processMpvFrame

load ('homographyPoints.mat');
options.rnsc_threshold = 5; options.rnsc_confidence = 0.99;
figure; imagesc(imgPrev); colormap gray; axis image;
line([data.xRect data.xRect(1)],[data.yRect data.yRect(1)], 'color', 'y');
title('imgPrev with the original rectangle');
figure; 
tic; [dataOut xNewOut] = processMpvFrame(data,imgPrev,imgNew,xPrev,xNew,options); t=toc;
fprintf('Found %d inliers %.2f percent of tentative correspondences in %.3f sec.\n\n', length(xNewOut.ID), 100*length(xNewOut.ID)/length(xNew.ID), t);
fprintf('Homography matrix:\n'); disp(dataOut.H);
fprintf('Transformed rectangle:\n'); disp([dataOut.xRect; dataOut.yRect]);
tic; [dataOut xNewOut] = processMpvFrame(data,imgPrev,imgNew,xPrev,xNew,options); t=toc;
fprintf('Found %d inliers %.2f percent of tentative correspondences in %.3f sec.\n\n', length(xNewOut.ID), 100*length(xNewOut.ID)/length(xNew.ID), t);
fprintf('Homography matrix:\n'); disp(dataOut.H);
fprintf('Transformed rectangle:\n'); disp([dataOut.xRect; dataOut.yRect]);
tic; [dataOut xNewOut] = processMpvFrame(data,imgPrev,imgNew,xPrev,xNew,options); t=toc;
fprintf('Found %d inliers %.2f percent of tentative correspondences in %.3f sec.\n\n', length(xNewOut.ID), 100*length(xNewOut.ID)/length(xNew.ID), t);
fprintf('Homography matrix:\n'); disp(dataOut.H);
fprintf('Transformed rectangle:\n'); disp([dataOut.xRect; dataOut.yRect]);
title('imgNew with the transformed rectangle');
%% harris detektor, kontrola track_init (byl-li implentovan)

if  (exist('track_init','file'))
    imgPrev = im2double(imread('cameraman.tif')); [h w]=size(imgPrev);
    options.sigma_d = 1; options.sigma_i = 1.5; options.thresh = 0.080^4;
    options.ROI = [1 1 h w];
    xPrev = track_init(imgPrev, options); 
    fprintf('Found %d harris points.\n\n',length(xPrev.x));
    figure; imagesc(imgPrev); colormap gray; axis image; showPoints(xPrev);title('Harris detektor, sigma_d 1, sigma_i 1.5');
else
    fprintf('track_init.m not implemented\n\n');
end
%% kontrola sledovani

cv08 % spusti vase vlastni nastaveni parametru, ale s upravenou, testovaci processMpvVideo